package com.fp.persistence.pgeneral.gene;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENECASHCLOSEHEADER*/
@Embeddable
public class TgeneCashCloseHeaderKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="WORKINGDATE", nullable=false,updatable=false)

/**
* Fecha de trabajo en la cual se origina la transferencia
*/
private Date workingdate;

@Column(name="USERCODE", nullable=false,updatable=false)

/**
* Codigo de usuario que origina la transferencia
*/
private String usercode;

@Column(name="CURRENCYCODE", nullable=false,updatable=false)

/**
* Codigo de moneda
*/
private String currencycode;

@Column(name="OFFICECODE", nullable=false,updatable=false)

/**
* Codigo de oficina
*/
private Integer officecode;

@Column(name="BRANCHCODE", nullable=false,updatable=false)

/**
* Codigo de sucursal
*/
private Integer branchcode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania al que pertenece la oficina
*/
private Integer companycode;

@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el registro.
*/
private Timestamp dateto;

/**Contructor por defecto*/
public TgeneCashCloseHeaderKey(){}
/**Contructor de TgeneCashCloseHeaderKey
@param pWorkingdate Fecha de trabajo en la cual se origina la transferencia
@param pUsercode Codigo de usuario que origina la transferencia
@param pCurrencycode Codigo de moneda
@param pOfficecode Codigo de oficina
@param pBranchcode Codigo de sucursal
@param pCompanycode Codigo de compania al que pertenece la oficina
@param pDateto Fecha hasta la cual esta vigente el registro.
*/
public TgeneCashCloseHeaderKey(Date pWorkingdate,String pUsercode,String pCurrencycode,Integer pOfficecode,Integer pBranchcode,Integer pCompanycode,Timestamp pDateto){
 workingdate=pWorkingdate;
 usercode=pUsercode;
 currencycode=pCurrencycode;
 officecode=pOfficecode;
 branchcode=pBranchcode;
 companycode=pCompanycode;
 dateto=pDateto;
}
/**Obtiene el valor de workingdate
@return valor de workingdate*/
public Date getWorkingdate(){
  return workingdate;
}
/**Fija el valor de workingdate
@param pWorkingdate nuevo Valor de workingdate*/
public void setWorkingdate(Date pWorkingdate){
  workingdate=pWorkingdate;
}

/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de currencycode
@return valor de currencycode*/
public String getCurrencycode(){
  return currencycode;
}
/**Fija el valor de currencycode
@param pCurrencycode nuevo Valor de currencycode*/
public void setCurrencycode(String pCurrencycode){
  currencycode=pCurrencycode;
}

/**Obtiene el valor de officecode
@return valor de officecode*/
public Integer getOfficecode(){
  return officecode;
}
/**Fija el valor de officecode
@param pOfficecode nuevo Valor de officecode*/
public void setOfficecode(Integer pOfficecode){
  officecode=pOfficecode;
}

/**Obtiene el valor de branchcode
@return valor de branchcode*/
public Integer getBranchcode(){
  return branchcode;
}
/**Fija el valor de branchcode
@param pBranchcode nuevo Valor de branchcode*/
public void setBranchcode(Integer pBranchcode){
  branchcode=pBranchcode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Implementación de la comparación de TgeneCashCloseHeaderKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneCashCloseHeaderKey))return false;
  TgeneCashCloseHeaderKey that = (TgeneCashCloseHeaderKey) o;
  if (this.getWorkingdate() == null || that.getWorkingdate() == null){
      return false;
  }
  if (! this.getWorkingdate().equals(that.getWorkingdate())){
    return false;
  }
  if (this.getUsercode() == null || that.getUsercode() == null){
      return false;
  }
  if (! this.getUsercode().equals(that.getUsercode())){
    return false;
  }
  if (this.getCurrencycode() == null || that.getCurrencycode() == null){
      return false;
  }
  if (! this.getCurrencycode().equals(that.getCurrencycode())){
    return false;
  }
  if (this.getOfficecode() == null || that.getOfficecode() == null){
      return false;
  }
  if (! this.getOfficecode().equals(that.getOfficecode())){
    return false;
  }
  if (this.getBranchcode() == null || that.getBranchcode() == null){
      return false;
  }
  if (! this.getBranchcode().equals(that.getBranchcode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneCashCloseHeaderKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getWorkingdate() == null ? 0 : this.getWorkingdate().hashCode());
    result = result * 37 + (this.getUsercode() == null ? 0 : this.getUsercode().hashCode());
    result = result * 37 + (this.getCurrencycode() == null ? 0 : this.getCurrencycode().hashCode());
    result = result * 37 + (this.getOfficecode() == null ? 0 : this.getOfficecode().hashCode());
    result = result * 37 + (this.getBranchcode() == null ? 0 : this.getBranchcode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
